#ifndef W2LFUNCTIONS_H_INCLUDED
#define W2LFUNCTIONS_H_INCLUDED
#include <string>
using std::string;
#include <stdarg.h>
// define opterators and constants
#define W2LAND &&
#define W2LOR ||
#define W2LEQ ==
#define W2LNEQ !=
#define W2LLT <
#define W2LGT >
#define W2LLE <=
#define W2LGE >=
#define W2LTRUE true
#define W2LFALSE false


typedef double       w2lfloat;
typedef bool         w2lbool;

extern void w2ldecimal_point(char const point);
extern int w2l_exe_agument(int ac,char const*av[]);
extern void w2ldefault_output(char const*default_output_file);
extern void w2lnewcommand(w2lfloat const var_val,char const*var_name,char const*var_format);
extern void w2lnewboolean(w2lbool const var_val,char const*var_name);
inline w2lfloat w2lif(bool condition,w2lfloat const val_if_true,w2lfloat const val_if_false){ return condition ? val_if_true : val_if_false; }
extern w2lfloat w2lmod(w2lfloat const dividend,w2lfloat const divisor);
extern w2lfloat w2lround(w2lfloat const val,w2lfloat const post_point_digit_count);
extern w2lfloat w2lproduct(unsigned int const arg_count,...);
extern w2lfloat w2laverage(unsigned int const arg_count,...);
extern w2lfloat w2lint(w2lfloat const );
extern w2lfloat w2labs(w2lfloat const );
inline w2lfloat w2lmax(w2lfloat const a,w2lfloat const b){ return a > b ? a : b;}
inline w2lfloat w2lmin(w2lfloat const a,w2lfloat const b){ return a < b ? a : b;}
inline bool w2lor(bool const a,bool const b ){ return a|| b; }
inline bool w2land(bool const a,bool const b ){ return a&& b; }
extern w2lfloat w2lpower(w2lfloat const to_be_raised,w2lfloat const to_power);



#endif // W2LFUNCTIONS_H_INCLUDED
